<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem">
        <ReturnButton v-on:clickEvent="viewListAmort" title="Ir a Amortizaciones" :offsetArrow="19" :spanTitle="4" class="text-end"></ReturnButton>

      <!-- COMPONENTE TITULO -->
      <div style="padding-top: 1.5rem">
        <Title Title="NUEVO ESQUEMA DE AMORTIZACIÓN"> </Title>
      </div>

      </el-header>
      <el-main style="margin:3rem 12rem">
        <h3 class="text-orange" style="margin-bottom:2.5rem">DATOS DEL ESQUEMA DE AMORTIZACIÓN</h3>
        <el-form :rules="rules" ref="form" :model="form">
          <el-form-item style="margin: 1.5rem 0 0" prop="originalTitle">
            <el-row>
              <el-col :span="5">
                <p class="fonts-bold-general">Nombre del Esquema:</p>
              </el-col>
              <el-col :span="7">
                <el-input v-model="form.schemaName" size="small"></el-input>
              </el-col>
            </el-row>
          </el-form-item>
          <el-form-item style="margin: 1.5rem 0 0" prop="amortizationType">
            <el-row :gutter="20">
              <el-col :span="5">
                <p class="fonts-bold-general" >Tipo de Amortización:</p>
              </el-col>
              <el-col :span="7">
                <el-select v-model="form.amortizationType" placeholder="Seleccionar" size="small">
                  <el-option label="Pasadas" value="Pasadas"></el-option>
                  <el-option label="Otros" value="Otros"></el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>

          <el-form-item style="margin: 1.5rem 0 0" prop="amortizationTypeProcess">
            <el-row :gutter="20">
              <el-col :span="5">
                <p class="fonts-bold-general"><span style="color: #fc0000; margin-right: 4px;">*</span>Tipo de Proceso:</p>
              </el-col>
              <el-col :span="7">
                <el-select v-model="form.amortizationTypeProcess" placeholder="Seleccionar" size="small" @change="isExit(form.amortizationTypeProcess, form.numberOfAmortization)">
                  <el-option label="Pasadas Tipo 1" value="PAS"></el-option>
                  <el-option label="Pasadas Tipo 2" value="PAS2"></el-option>
                  <el-option label="Pasadas Tipo 3" value="PAS3"></el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>

          <el-form-item style="margin: 1.5rem 0 0" prop="checkedContractTypes">
            <el-row>
              <el-col :span="5">
                <p class="fonts-bold-general"><span style="color: #fc0000; margin-right: 4px;">*</span>Tipo de Contrato:</p>
              </el-col> 
              <el-col :span="5"> 
                <el-checkbox-group v-model="checkedContractTypes"  :min="2" :max="2">
                  <el-checkbox v-for="contract in contracts" :label="contract" :key="contract" style="margin:0 1rem">{{contract}}</el-checkbox>
                </el-checkbox-group>
              </el-col>
            </el-row>
          </el-form-item>
          <hr style="margin-top:2.5rem">
           <el-form-item style="margin: 1.5rem 0 0" prop="checkedMaterialTypes">
            <el-row :gutter="20">
              <h3 class="text-orange" style="margin-left:0.5rem">MATERIALES</h3>
              <el-col :span="10">
                <el-checkbox :indeterminate="isIndeterminate2" v-model="checkAllMaterial" @change="handleCheckAllMaterial" style="margin:0 1rem">Seleccionar todos</el-checkbox>
                <el-checkbox-group v-model="checkedMaterialTypes" @change="materialChange" style="column-count: 2; flex-direction: row">
                  <el-checkbox v-for="materialType in allMaterialType" :label="materialType" :key="materialType" style="margin:0 1rem; line-height:1">
                    {{materialType}}
                  </el-checkbox>
                </el-checkbox-group>

                 <AppModal :show-dialog.sync="coincidenceModal" widthModal="43%"  v-if="coincidenceModal" nameClass="dialog-orange"  :rutImg="require(`@/assets/images/alerta.svg`)" sizeImg="80px"
                    :textBold="'¿Quieres priorizar la Amortización de ' + form.schemaName + ' para ' + this.aType + ' ?' " :parrafo="'La amortización ' + this.beforeSchema + ' no se elimanará.'"
                    classBtn1="border-orange" typeBtn1="primary" btn1="CANCELAR" btn2="PRIORIZAR" v-on:btnEvent="cancelModalPrioritize(coincidenceModal)"  v-on:eventBtn="coincidenceModal = false">
                 </AppModal> 

              </el-col>
            </el-row>
          </el-form-item>
          <hr style="margin-top:2.5rem">
          <el-form-item style="margin: 1.5rem 0 5rem" prop="details">
            <el-row :gutter="20">
              <h3 class="text-orange" style="margin-left:0.5rem; margin-bottom:1.5rem">DETALLES DEL ESQUEMA</h3>
              <el-row :gutter="10">
                <el-col :span="5">
                  <p class="fonts-bold-general" style="margin-left:0.5rem"><span style="color: #fc0000; margin-right: 4px;">*</span>N° de Amortizaciones:</p>
                </el-col>
                <el-form-item class="ml-12" prop="numberOfAmortization">
                  <el-col :span="2">
                      <el-input v-model="form.numberOfAmortization" size="small" ref="namort"  @keyup.enter.native="addPercentage" v-on:keypress.native="isNumber" @change="isExit(form.amortizationTypeProcess, form.numberOfAmortization)"></el-input>
                  </el-col>
                </el-form-item>
              </el-row>
              <el-row :gutter="20">
                <p class="fonts-bold-general" style="margin:2rem 13.1rem 0.8rem">Porcentaje de Amortización:</p>
                <el-col v-for="(num, index) in amortArray" :key="index">
                  <el-col :span="2" :offset="5">
                    <el-input v-model="num.indexPercentage" size="small" :disabled="true"></el-input>
                  </el-col>
                  <el-col :span="4">
                    <el-input v-model="num.amortizationP" @keyup.enter.native="calculateAmortPercent" size="small"  v-on:keypress.native="isNumber">
                      <template slot="append">%</template>
                    </el-input>
                  </el-col>
                </el-col>
              </el-row>
              <hr style="width:8.5rem; margin:0.5rem 0 0.4rem 17.9rem">
              <el-col :span="2" style="margin-left:12.3rem" >
                  <p class="fonts-bold-general"><span style="color: #fc0000; margin-right: 4px;">*</span>Total:</p>
                </el-col>
                <el-form-item style="margin-left: 13rem" prop="total">
                  <el-col :span="5">
                    <el-input v-model="form.total" size="small" :disabled="true">
                      <template slot="append">%</template>
                    </el-input>
                  </el-col>
                </el-form-item>
            </el-row>
          </el-form-item>
          <el-row type="flex" justify="end">
            <el-button @click="modalCancelButton = true" class="text-orange border-orange">CANCELAR</el-button>
            <el-button type="primary" @click="submitAmort" style="min-width: 118.77px;">CREAR</el-button>
          </el-row> 

          <!-- Modal validación-->
          <el-dialog :visible.sync="modalAmortHigherPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-red"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/alerta.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> <span class="text-red text-bold"> SUPERA </span> el 100%  </p>
              </el-col>
            </el-row>
          </el-dialog>

          <el-dialog :visible.sync="modalAmortLessPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-red"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/alerta.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> <span class="text-red text-bold"> ES MENOR </span> a 100%  </p>
              </el-col>
            </el-row>
          </el-dialog>

          <el-dialog :visible.sync="modalAmortCorrectPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-green"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/check-verde.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> es <strong>100%</strong></p>
              </el-col>
            </el-row>
          </el-dialog>

          <!-- modal de crear -->
          <AppModalSuccess :show-dialog.sync="amortizationModal" widthModal="40%"  v-if="amortizationModal" :parrafo="'El esquema de Amortización ' + form.schemaName + ' se ha creado.' " :styleModal="true"
             btn1="NUEVO ESQUEMA" btn2="VER ESQUEMAS" v-on:btnEvent="cleanAllInputs()" @btnEvent="amortizationModal = false"  v-on:eventBtn="viewListAmort">
          </AppModalSuccess>

           <!-- Modal botón cancelar -->
            <AppModalDanger :show-dialog.sync="modalCancelButton"   v-if="modalCancelButton" v-on:btnEvent="viewListAmort"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
          </AppModalDanger>
        </el-form> 
      </el-main>
    </div>
    <!-- Modal formulario invalido -->
    <el-dialog
      :visible.sync="invalidForm"
      width="30%"
      center
      :show-close="false"
      custom-class="dialog-red">
      <el-row>
        <el-col :span="5"><img src="@/assets/images/alerta.svg" width="80%" alt="emoticon"></el-col>
        <el-col :span="18" :offset="1">
          <div style="line-height: 22px;" v-html="textModalInvalid"></div>
        </el-col>
      </el-row>
    </el-dialog>
  </div>
</template>
<script>

import ReturnButton from '@/components/ReturnButton.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import {HTTP} from '@/main.js'
import Title from '@/components/Title.vue'  


const contractOptions = ['Extranjero', 'Local'];
const allMaterialTypeOptions = ['Dibujos','Series','Largometrajes','Novelas', 'Miniseries','Programas Especiales'];

export default {
  components: {
    ReturnButton,
    AppModal,
    AppModalSuccess,
    AppModalDanger,
    Title
  },
  data() {
    return {
      // getAmort:JSON.parse(this.$localStorage.get('tableAmort')),
      amortArray:[],
      // numberOfAmortization:'',
      amortizationP:'',
      indexPercentage:'',
      form: {
        schemaName: '',
        amortizationType:'',
        total:'',
        amortizationTypeProcess: '',
        numberOfAmortization: ''
      },
      checkedContractTypes: ['Extranjero', 'Local'],
      contracts: contractOptions,
      isIndeterminate: true,
      checkAllMaterial:false,
      checkedMaterialTypes: [],
      allMaterialType:allMaterialTypeOptions,
      isIndeterminate2: true,
      onlyPercentage:[],
      description:[],
      amortizationModal: false,
      coincidenceModal: false,
      aType:'',
      beforeSchema:'',
      modalCancelButton: false,
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      dataAmort: JSON.parse(localStorage.getItem('tableAmort')),
      allTypesEsquemas: [],
      codePass: "",
      valueMaterial: '',
      modalAmortCorrectPercent: false,
      modalAmortLessPercent: false,
      modalAmortHigherPercent: false,
      rules: {
        amortizationTypeProcess: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        total: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        numberOfAmortization: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
      },
      invalidForm: false,
      textModalInvalid: '<p>Por favor, ingrese todos los campos requeridos.</p>',
      isAcceptCreated: true
    };
  },
  created () {
    this.gettingUsername()
  },
  methods: {
    async isExit(type, currence) {
      console.log('isExit')
      if(type && type !== '' && currence && currence !== '' && currence !== '0') {
        let {data} = await HTTP.post(`amortization/filterSchema`, {
          numOcurrencia: currence,
          tprCodigo: type
        })
        let valueExist = data.exist
        // console.log({valueExist})
        if(valueExist) {
          // this.textModalInvalid = `<p>Ya existe este <strong>Esquema de Amortización:</strong> </br>
          // Tipo de Proceso: ${type} </br>
          // N° de Amortizaciones: ${currence}</p>`
          this.textModalInvalid = '<p>No se puede crear este <strong>Esquema de Amortización</strong> porque ya existe otro Esquema con el mismo número de amortización y tipo de proceso<p>'
          this.invalidForm = true
          this.isAcceptCreated = false
          // console.log('debe salir modal de que este tipo de amortizacion ya existe')
        } else {
          this.isAcceptCreated = true
          // console.log('se puede crear')
        }
        // console.log({data, valueExist}, 'isExit')
      }
    },
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    cancelModalPrioritize (coincidenceModal) {
      if (this.checkedMaterialTypes.includes(this.valueMaterial.pop())) {
        let index = this.checkedMaterialTypes.findIndex(checkedMaterialType => checkedMaterialType === this.valueMaterial.pop())
        this.checkedMaterialTypes[index] = ''
      }
      this.coincidenceModal = false
    },
    handleCheckAllMaterial (val) {
      this.checkedMaterialTypes = val ? allMaterialTypeOptions : [];
      this.isIndeterminate2 = false;
    },
    materialChange (value) {
      this.valueMaterial = value;
      let checkedCount = value.length;
      this.checkAllMaterial = checkedCount === this.allMaterialType.length;
      this.isIndeterminate2 = checkedCount > 0 && checkedCount < this.allMaterialType.length;
      
      // let arrTypes= this.getAmort.types
      let arrTypes= this.dataAmort
      let arrMatTypes, repSchema
      
      // seleccionando checkbox
      for (let i=0; i<value.length;i++){
        this.aType = value[i]
        // obtención del nombre y los tipos de materiales
        for (let j=0; j< arrTypes.length ; j++){
          arrMatTypes= arrTypes[j].materialTypes
          repSchema= arrTypes[j].schemaName
          for (let m=0; m< arrMatTypes.length; m++){
            if(this.aType=== arrMatTypes[m]){
              this.coincidenceModal = true
              this.beforeSchema= repSchema
            }
          }
        }
      }
    },
    addPercentage(){
      this.form.total=''
      const endTravel = this.amortArray.length;
      if (this.form.numberOfAmortization) {
        if (this.amortArray.length === 0 ) {
          this.amortArray = []
          for (var i = 0; i < this.form.numberOfAmortization; i++) {
            this.amortArray[i] = {'indexPercentage': i+1, 'amortizationP': ''}
          }
          this.$refs.namort.blur();
        } else {
          if( this.amortArray.length < Number(this.form.numberOfAmortization) ) {
            for (var i = this.amortArray.length; i < Number(this.form.numberOfAmortization); i++) {
              let contentPosition = {'indexPercentage': i+1, 'amortizationP': ''}
              this.amortArray.push(contentPosition) 
            }
          } else {
            for (var i = Number(this.form.numberOfAmortization); i < endTravel; i++) {
              this.amortArray.splice(i,(endTravel - Number(this.form.numberOfAmortization))) 
            }
          }
        }      
        
      }
    },
    showModalAmortization (total) {
      if(total < 100) {
        this.modalAmortLessPercent = true
      }
      else if (total == 100) {
        this.modalAmortCorrectPercent = true
      }
      else {
        this.modalAmortHigherPercent = true
      }
    },
    calculateAmortPercent () {
      let total = 0
      for (var i = 0; i < this.amortArray.length; i++) {
        total += Number(this.amortArray[i].amortizationP)
        if(i == (this.amortArray.length -1 ) &&  Number(this.amortArray[i].amortizationP) !== 0) {
         this.showModalAmortization(total)
        }
      }
      this.form.total = total;
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }
    },
    viewListAmort () {
      this.$router.push({ name: "amortization" });
    },
    cleanAllInputs () {
      this.$refs['form'].resetFields()
      this.form.schemaName= ''
      this.form.amortizationType=''
      this.form.amortizationTypeProcess= ''
      this.checkedContractTypes= ['Extranjero', 'Local'],
      this.checkedMaterialTypes=[]
      this.amortArray=[]
      this.form.total=''
      this.isIndeterminate = true
      this.isIndeterminate2 = true
      this.form.numberOfAmortization = ''
    },
    post() {
      let schemaAmort = {
        schemaName: this.form.schemaName,
        totalAmort: this.form.total,
        amortizationType:this.form.amortizationType,
        contractType:this.checkedContractTypes,
        materialTypes: this.checkedMaterialTypes.length > 0 ? this.checkedMaterialTypes : "No ingresado",
        amortizationPercentage:this.amortArray.length,
        arrayOfPercentage:this.amortArray,
        description:this.description,
        userName:this.userName,
        userEmail:this.userEmail,
        codeAmort: this.form.amortizationTypeProcess,
        descriptionOracle: this.descriptionOracle,
        show: true
      };
      console.log('POST', {schemaAmort})
      HTTP.post(`amortization/`, schemaAmort)
      .then(res => {
        this.amortizationModal = true 
      }).catch(err => console.log(err))
    },
    addDescriptionAmortization() {
      let porcentajes = [...new Set(this.amortArray.map(amortization=> parseFloat(amortization.amortizationP)))]
      
      this.description = []
      this.descriptionOracle = []
      // porcentajes.sort();
      porcentajes.forEach(porcentaje=>{
        let cantidad = this.amortArray.filter(el=>parseFloat(el.amortizationP)===porcentaje).length;
        this.description.push(`${cantidad} Pasada de ${porcentaje}%`)
        this.descriptionOracle.push(`${cantidad} PAS. ${porcentaje}%`)
      })

    },
    submitAmort () {
      console.log(this.form.total)
      let dataIncomplete = this.amortArray.filter((e) => e.amortizationP == '0' || e.amortizationP == '')
      this.$refs['form'].validate((valid) => {
        if (this.isAcceptCreated && valid && dataIncomplete.length == 0 && this.form.total == 100) {
          this.addDescriptionAmortization()
          this.post()
        } else {
          if(this.isAcceptCreated == false) {
            this.textModalInvalid = '<p>No se puede crear este <strong>Esquema de Amortización</strong> porque ya existe otro Esquema con el mismo número de amortización y tipo de proceso<p>'
          } else {
            if(this.form.total !== 100) {
              this.textModalInvalid = '<p>El total de los porcentajes de amortización debe sumar <span class="text-red text-bold">100%</span>, ¡Verifique la información ingresada!<p>'
            } else {
              this.textModalInvalid = '<p>Por favor, ingrese todos los campos requeridos.<p>'
            }
          }
          this.invalidForm = true
          return false;
        }
      })
    },
  }
}
</script>